
  #define SW  PORTD.F0
  #define SW1  PORTD.F1
sbit LCD_RS at RC2_bit;

 sbit LCD_EN at RC3_bit;

 sbit LCD_D4 at RC4_bit;

 sbit LCD_D5 at RC5_bit;

 sbit LCD_D6 at RC6_bit;

 sbit LCD_D7 at RC7_bit;

 sbit LCD_RS_Direction at TRISC2_bit;

 sbit LCD_EN_Direction at TRISC3_bit;

 sbit LCD_D4_Direction at TRISC4_bit;

 sbit LCD_D5_Direction at TRISC5_bit;

 sbit LCD_D6_Direction at TRISC6_bit;

 sbit LCD_D7_Direction at TRISC7_bit;


    unsigned int v,vp,ip,i;
  char *volt="00.0";
  char *current="0.00";
      char look(int a)
{
  switch(a)
  {
    case 0:
      return '0';
    case 1:
      return '1';
    case 2:
      return '2';
    case 3:
      return '3';
    case 4:
      return '4';
    case 5:
      return '5';
    case 6:
      return '6';
    case 7:
      return '7';
    case 8:
      return '8';
    case 9:
      return '9';
    default:
      return '.';
  }
}
    //Function for reading AC Voltage
void voltage_READ(void)
 {
 float V;
 char txt[5];
char txt1[5];
 float max;
 int i;
 int t[40];
 ADCON0.ADON=1;
 for(i=0; i<=39; i++)
 {
 v= ADC_Read(1); //Digital value convert
 v =v*(10.0/1023.0);
 v=(v-5.0);
 t[i]=v*110.1909091;
 }

 ADCON0.ADON=0;
 max=t[0];
 for(i=0; i<=39; i++)
 {
 if(max<t[i])
 max=t[i];
 }
 max=max*.707106781;
 intToStr(max, txt);
 Lcd_out(1,9,txt);
 delay_ms(1000);
 }  
 
//Reading DC Voltage and DC Current
void main()
{
     TRISA=0XFF;
     TRISD=0X0F;
  LCD_init();
  LCD_cmd(_LCD_CLEAR);
  LCD_cmd(_LCD_CURSOR_OFF);
  //Reading DC and Idc Current
  //if(SW==0)
  delay_ms(1000);
  if(SW==0)
  {
     v=ADC_read(3);
    i=ADC_Read(0);
   i=(i*4.89)/0.47;
     v=((v*4.89)/1.3)*5.2; //use of R1=3.9K and R2=1.3K
     
     if(v!=vp||i!=ip)
       {
     vp=v;
     ip=i;
     volt[0] = look(v/10000);
    volt[1] = look((v/1000)%10);
    volt[3] = look((v/100)%10);
    Lcd_Out(1,1,"DC= ");
    Lcd_Out(1,11,volt);
    Lcd_Out(1,16,"V");

    current[0] = look(i/1000);
    current[2] = look((i/100)%10);
    current[3] = look((i/10)%10);
    Lcd_Out(2,1,"Idc = ");
    Lcd_Out(2,11,current);
    Lcd_Out(2,15,"A");
    Delay_ms(500);
    }
    }
    else if(SW1==0)
    {
     Lcd_out(1,1, "Voltage:");
   voltage_READ();
    }
     while(1);
}